"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var cache = {};

function isBuiltIn(name) {
  if (!(name in cache)) {
    try {
      require.resolve("../built-ins/" + name);
      cache[name] = true;
    } catch (ex) {
      cache[name] = false;
    }
  }

  return cache[name];
}

exports["default"] = function (_ref) {
  var Plugin = _ref.Plugin;
  var types = _ref.types;
  var options = _ref.options;

  return new Plugin("babel-plugin-react-titanium", {
    visitor: {
      JSXElement: function JSXElement(node, parent, scope, file) {
        var name = node.openingElement.name.name;

        if (typeof name !== 'string') {
          return;
        }

        if (isBuiltIn(name)) {
          file.addImport("react-titanium/lib/built-ins/" + name);
        }
      }
    }
  });
};

module.exports = exports["default"];