'use strict';

var _extends = require('babel-runtime/helpers/extends')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _ReactTitaniumBridge = require('../ReactTitaniumBridge');

(0, _ReactTitaniumBridge.register)("ipad-popover", "Ti.UI.iPad.Popover", {
  factory: function factory(props) {
    return Ti.UI.iPad.createPopover(props);
  },

  create: function create(props, handlers, getChildren) {
    var children = getChildren();

    (0, _invariant2['default'])(children.length === 1, '<ipad-popover> requires exactly 1 children (got ' + children.length + ')');

    var view = this.factory(_extends({}, props, {
      contentView: children[0]
    }));

    (0, _ReactTitaniumBridge.attachListeners)(view, handlers);

    return view;
  }
});