'use strict';

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _ReactTitaniumBridge = require('../ReactTitaniumBridge');

(0, _ReactTitaniumBridge.register)("tabgroup", "Ti.UI.TabGroup", {
  factory: function factory(props) {
    return Ti.UI.createPickerColumn(props);
  },

  create: function create(props, handlers, getChildren) {
    var children = getChildren();

    (0, _invariant2['default'])(children.every(function (child) {
      return child.apiName === 'Ti.UI.PickerRow';
    }), "Only <pickerrow>s can be children of a <pickercolumn>");

    var view = this.factory(props);

    var i = 0;
    var l = children.length;

    for (; i < l; ++i) {
      view.addRow(children[i]);
    }

    (0, _ReactTitaniumBridge.attachListeners)(view, handlers);

    return view;
  }
});