'use strict';

var _extends = require('babel-runtime/helpers/extends')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _ReactTitaniumBridge = require('../ReactTitaniumBridge');

(0, _ReactTitaniumBridge.register)("tab", "Ti.UI.Tab", {
  factory: function factory(props) {
    return Ti.UI.createTab(props);
  },

  create: function create(props, handlers, getChildren) {
    var children = getChildren();

    (0, _invariant2['default'])(children.every(function (child) {
      return child.apiName === 'Ti.UI.Window';
    }), "Only <window>s can be children of a <tab>");

    var view = this.factory(_extends({}, props, {
      window: children[0]
    }));

    (0, _ReactTitaniumBridge.attachListeners)(view, handlers);

    return view;
  }
});