'use strict';

var _extends = require('babel-runtime/helpers/extends')['default'];

var _objectWithoutProperties = require('babel-runtime/helpers/object-without-properties')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = once;

function once(target, name, _ref) {
  var init = _ref.initializer;

  var rest = _objectWithoutProperties(_ref, ['initializer']);

  var key = '_' + name + '_has_run';

  return _extends({
    initializer: function initializer() {
      var _this = this;

      var fn = init.call(this);

      return function (arg) {
        if (!arg) return;
        if (_this[key]) return;

        fn.call(_this, arg);
        _this[key] = true;
      };
    }
  }, rest);
}

module.exports = exports['default'];